// !!! This is a file automatically generated by hipify!!!
/*
  Provides the implementations of cuSPARSE function templates.
*/

#include <ATen/hip/HIPSparseBlas.h>

namespace at::cuda::sparse {

template <>
void csrgeam2_bufferSizeExt<float>(
    CUSPARSE_CSRGEAM2_BUFFERSIZE_ARGTYPES(float)) {
  TORCH_CUDASPARSE_CHECK(hipsparseScsrgeam2_bufferSizeExt(
      handle,
      m,
      n,
      alpha,
      descrA,
      nnzA,
      csrSortedValA,
      csrSortedRowPtrA,
      csrSortedColIndA,
      beta,
      descrB,
      nnzB,
      csrSortedValB,
      csrSortedRowPtrB,
      csrSortedColIndB,
      descrC,
      csrSortedValC,
      csrSortedRowPtrC,
      csrSortedColIndC,
      pBufferSizeInBytes));
}

template <>
void csrgeam2_bufferSizeExt<double>(
    CUSPARSE_CSRGEAM2_BUFFERSIZE_ARGTYPES(double)) {
  TORCH_CUDASPARSE_CHECK(hipsparseDcsrgeam2_bufferSizeExt(
      handle,
      m,
      n,
      alpha,
      descrA,
      nnzA,
      csrSortedValA,
      csrSortedRowPtrA,
      csrSortedColIndA,
      beta,
      descrB,
      nnzB,
      csrSortedValB,
      csrSortedRowPtrB,
      csrSortedColIndB,
      descrC,
      csrSortedValC,
      csrSortedRowPtrC,
      csrSortedColIndC,
      pBufferSizeInBytes));
}

template <>
void csrgeam2_bufferSizeExt<c10::complex<float>>(
    CUSPARSE_CSRGEAM2_BUFFERSIZE_ARGTYPES(c10::complex<float>)) {
  TORCH_CUDASPARSE_CHECK(hipsparseCcsrgeam2_bufferSizeExt(
      handle,
      m,
      n,
      reinterpret_cast<const hipComplex*>(alpha),
      descrA,
      nnzA,
      reinterpret_cast<const hipComplex*>(csrSortedValA),
      csrSortedRowPtrA,
      csrSortedColIndA,
      reinterpret_cast<const hipComplex*>(beta),
      descrB,
      nnzB,
      reinterpret_cast<const hipComplex*>(csrSortedValB),
      csrSortedRowPtrB,
      csrSortedColIndB,
      descrC,
      reinterpret_cast<const hipComplex*>(csrSortedValC),
      csrSortedRowPtrC,
      csrSortedColIndC,
      pBufferSizeInBytes));
}

template <>
void csrgeam2_bufferSizeExt<c10::complex<double>>(
    CUSPARSE_CSRGEAM2_BUFFERSIZE_ARGTYPES(c10::complex<double>)) {
  TORCH_CUDASPARSE_CHECK(hipsparseZcsrgeam2_bufferSizeExt(
      handle,
      m,
      n,
      reinterpret_cast<const hipDoubleComplex*>(alpha),
      descrA,
      nnzA,
      reinterpret_cast<const hipDoubleComplex*>(csrSortedValA),
      csrSortedRowPtrA,
      csrSortedColIndA,
      reinterpret_cast<const hipDoubleComplex*>(beta),
      descrB,
      nnzB,
      reinterpret_cast<const hipDoubleComplex*>(csrSortedValB),
      csrSortedRowPtrB,
      csrSortedColIndB,
      descrC,
      reinterpret_cast<const hipDoubleComplex*>(csrSortedValC),
      csrSortedRowPtrC,
      csrSortedColIndC,
      pBufferSizeInBytes));
}

template <>
void csrgeam2<float>(CUSPARSE_CSRGEAM2_ARGTYPES(float)) {
  TORCH_CUDASPARSE_CHECK(hipsparseScsrgeam2(
      handle,
      m,
      n,
      alpha,
      descrA,
      nnzA,
      csrSortedValA,
      csrSortedRowPtrA,
      csrSortedColIndA,
      beta,
      descrB,
      nnzB,
      csrSortedValB,
      csrSortedRowPtrB,
      csrSortedColIndB,
      descrC,
      csrSortedValC,
      csrSortedRowPtrC,
      csrSortedColIndC,
      pBuffer));
}

template <>
void csrgeam2<double>(CUSPARSE_CSRGEAM2_ARGTYPES(double)) {
  TORCH_CUDASPARSE_CHECK(hipsparseDcsrgeam2(
      handle,
      m,
      n,
      alpha,
      descrA,
      nnzA,
      csrSortedValA,
      csrSortedRowPtrA,
      csrSortedColIndA,
      beta,
      descrB,
      nnzB,
      csrSortedValB,
      csrSortedRowPtrB,
      csrSortedColIndB,
      descrC,
      csrSortedValC,
      csrSortedRowPtrC,
      csrSortedColIndC,
      pBuffer));
}

template <>
void csrgeam2<c10::complex<float>>(
    CUSPARSE_CSRGEAM2_ARGTYPES(c10::complex<float>)) {
  TORCH_CUDASPARSE_CHECK(hipsparseCcsrgeam2(
      handle,
      m,
      n,
      reinterpret_cast<const hipComplex*>(alpha),
      descrA,
      nnzA,
      reinterpret_cast<const hipComplex*>(csrSortedValA),
      csrSortedRowPtrA,
      csrSortedColIndA,
      reinterpret_cast<const hipComplex*>(beta),
      descrB,
      nnzB,
      reinterpret_cast<const hipComplex*>(csrSortedValB),
      csrSortedRowPtrB,
      csrSortedColIndB,
      descrC,
      reinterpret_cast<hipComplex*>(csrSortedValC),
      csrSortedRowPtrC,
      csrSortedColIndC,
      pBuffer));
}

template <>
void csrgeam2<c10::complex<double>>(
    CUSPARSE_CSRGEAM2_ARGTYPES(c10::complex<double>)) {
  TORCH_CUDASPARSE_CHECK(hipsparseZcsrgeam2(
      handle,
      m,
      n,
      reinterpret_cast<const hipDoubleComplex*>(alpha),
      descrA,
      nnzA,
      reinterpret_cast<const hipDoubleComplex*>(csrSortedValA),
      csrSortedRowPtrA,
      csrSortedColIndA,
      reinterpret_cast<const hipDoubleComplex*>(beta),
      descrB,
      nnzB,
      reinterpret_cast<const hipDoubleComplex*>(csrSortedValB),
      csrSortedRowPtrB,
      csrSortedColIndB,
      descrC,
      reinterpret_cast<hipDoubleComplex*>(csrSortedValC),
      csrSortedRowPtrC,
      csrSortedColIndC,
      pBuffer));
}

template <>
void bsrmm<float>(CUSPARSE_BSRMM_ARGTYPES(float)) {
  TORCH_CUDASPARSE_CHECK(hipsparseSbsrmm(
      handle,
      dirA,
      transA,
      transB,
      mb,
      n,
      kb,
      nnzb,
      alpha,
      descrA,
      bsrValA,
      bsrRowPtrA,
      bsrColIndA,
      blockDim,
      B,
      ldb,
      beta,
      C,
      ldc));
}

template <>
void bsrmm<double>(CUSPARSE_BSRMM_ARGTYPES(double)) {
  TORCH_CUDASPARSE_CHECK(hipsparseDbsrmm(
      handle,
      dirA,
      transA,
      transB,
      mb,
      n,
      kb,
      nnzb,
      alpha,
      descrA,
      bsrValA,
      bsrRowPtrA,
      bsrColIndA,
      blockDim,
      B,
      ldb,
      beta,
      C,
      ldc));
}

template <>
void bsrmm<c10::complex<float>>(CUSPARSE_BSRMM_ARGTYPES(c10::complex<float>)) {
  TORCH_CUDASPARSE_CHECK(hipsparseCbsrmm(
      handle,
      dirA,
      transA,
      transB,
      mb,
      n,
      kb,
      nnzb,
      reinterpret_cast<const hipComplex*>(alpha),
      descrA,
      reinterpret_cast<const hipComplex*>(bsrValA),
      bsrRowPtrA,
      bsrColIndA,
      blockDim,
      reinterpret_cast<const hipComplex*>(B),
      ldb,
      reinterpret_cast<const hipComplex*>(beta),
      reinterpret_cast<hipComplex*>(C),
      ldc));
}

template <>
void bsrmm<c10::complex<double>>(
    CUSPARSE_BSRMM_ARGTYPES(c10::complex<double>)) {
  TORCH_CUDASPARSE_CHECK(hipsparseZbsrmm(
      handle,
      dirA,
      transA,
      transB,
      mb,
      n,
      kb,
      nnzb,
      reinterpret_cast<const hipDoubleComplex*>(alpha),
      descrA,
      reinterpret_cast<const hipDoubleComplex*>(bsrValA),
      bsrRowPtrA,
      bsrColIndA,
      blockDim,
      reinterpret_cast<const hipDoubleComplex*>(B),
      ldb,
      reinterpret_cast<const hipDoubleComplex*>(beta),
      reinterpret_cast<hipDoubleComplex*>(C),
      ldc));
}

template <>
void bsrmv<float>(CUSPARSE_BSRMV_ARGTYPES(float)) {
  TORCH_CUDASPARSE_CHECK(hipsparseSbsrmv(
      handle,
      dirA,
      transA,
      mb,
      nb,
      nnzb,
      alpha,
      descrA,
      bsrValA,
      bsrRowPtrA,
      bsrColIndA,
      blockDim,
      x,
      beta,
      y));
}

template <>
void bsrmv<double>(CUSPARSE_BSRMV_ARGTYPES(double)) {
  TORCH_CUDASPARSE_CHECK(hipsparseDbsrmv(
      handle,
      dirA,
      transA,
      mb,
      nb,
      nnzb,
      alpha,
      descrA,
      bsrValA,
      bsrRowPtrA,
      bsrColIndA,
      blockDim,
      x,
      beta,
      y));
}

template <>
void bsrmv<c10::complex<float>>(CUSPARSE_BSRMV_ARGTYPES(c10::complex<float>)) {
  TORCH_CUDASPARSE_CHECK(hipsparseCbsrmv(
      handle,
      dirA,
      transA,
      mb,
      nb,
      nnzb,
      reinterpret_cast<const hipComplex*>(alpha),
      descrA,
      reinterpret_cast<const hipComplex*>(bsrValA),
      bsrRowPtrA,
      bsrColIndA,
      blockDim,
      reinterpret_cast<const hipComplex*>(x),
      reinterpret_cast<const hipComplex*>(beta),
      reinterpret_cast<hipComplex*>(y)));
}

template <>
void bsrmv<c10::complex<double>>(
    CUSPARSE_BSRMV_ARGTYPES(c10::complex<double>)) {
  TORCH_CUDASPARSE_CHECK(hipsparseZbsrmv(
      handle,
      dirA,
      transA,
      mb,
      nb,
      nnzb,
      reinterpret_cast<const hipDoubleComplex*>(alpha),
      descrA,
      reinterpret_cast<const hipDoubleComplex*>(bsrValA),
      bsrRowPtrA,
      bsrColIndA,
      blockDim,
      reinterpret_cast<const hipDoubleComplex*>(x),
      reinterpret_cast<const hipDoubleComplex*>(beta),
      reinterpret_cast<hipDoubleComplex*>(y)));
}

#if AT_USE_HIPSPARSE_TRIANGULAR_SOLVE()

template <>
void bsrsv2_bufferSize<float>(CUSPARSE_BSRSV2_BUFFER_ARGTYPES(float)) {
  TORCH_CUDASPARSE_CHECK(hipsparseSbsrsv2_bufferSize(
      handle,
      dirA,
      transA,
      mb,
      nnzb,
      descrA,
      bsrValA,
      bsrRowPtrA,
      bsrColIndA,
      blockDim,
      info,
      pBufferSizeInBytes));
}

template <>
void bsrsv2_bufferSize<double>(CUSPARSE_BSRSV2_BUFFER_ARGTYPES(double)) {
  TORCH_CUDASPARSE_CHECK(hipsparseDbsrsv2_bufferSize(
      handle,
      dirA,
      transA,
      mb,
      nnzb,
      descrA,
      bsrValA,
      bsrRowPtrA,
      bsrColIndA,
      blockDim,
      info,
      pBufferSizeInBytes));
}

template <>
void bsrsv2_bufferSize<c10::complex<float>>(
    CUSPARSE_BSRSV2_BUFFER_ARGTYPES(c10::complex<float>)) {
  TORCH_CUDASPARSE_CHECK(hipsparseCbsrsv2_bufferSize(
      handle,
      dirA,
      transA,
      mb,
      nnzb,
      descrA,
      reinterpret_cast<hipComplex*>(bsrValA),
      bsrRowPtrA,
      bsrColIndA,
      blockDim,
      info,
      pBufferSizeInBytes));
}

template <>
void bsrsv2_bufferSize<c10::complex<double>>(
    CUSPARSE_BSRSV2_BUFFER_ARGTYPES(c10::complex<double>)) {
  TORCH_CUDASPARSE_CHECK(hipsparseZbsrsv2_bufferSize(
      handle,
      dirA,
      transA,
      mb,
      nnzb,
      descrA,
      reinterpret_cast<hipDoubleComplex*>(bsrValA),
      bsrRowPtrA,
      bsrColIndA,
      blockDim,
      info,
      pBufferSizeInBytes));
}

template <>
void bsrsv2_analysis<float>(CUSPARSE_BSRSV2_ANALYSIS_ARGTYPES(float)) {
  TORCH_CUDASPARSE_CHECK(hipsparseSbsrsv2_analysis(
      handle,
      dirA,
      transA,
      mb,
      nnzb,
      descrA,
      bsrValA,
      bsrRowPtrA,
      bsrColIndA,
      blockDim,
      info,
      policy,
      pBuffer));
}

template <>
void bsrsv2_analysis<double>(CUSPARSE_BSRSV2_ANALYSIS_ARGTYPES(double)) {
  TORCH_CUDASPARSE_CHECK(hipsparseDbsrsv2_analysis(
      handle,
      dirA,
      transA,
      mb,
      nnzb,
      descrA,
      bsrValA,
      bsrRowPtrA,
      bsrColIndA,
      blockDim,
      info,
      policy,
      pBuffer));
}

template <>
void bsrsv2_analysis<c10::complex<float>>(
    CUSPARSE_BSRSV2_ANALYSIS_ARGTYPES(c10::complex<float>)) {
  TORCH_CUDASPARSE_CHECK(hipsparseCbsrsv2_analysis(
      handle,
      dirA,
      transA,
      mb,
      nnzb,
      descrA,
      reinterpret_cast<const hipComplex*>(bsrValA),
      bsrRowPtrA,
      bsrColIndA,
      blockDim,
      info,
      policy,
      pBuffer));
}

template <>
void bsrsv2_analysis<c10::complex<double>>(
    CUSPARSE_BSRSV2_ANALYSIS_ARGTYPES(c10::complex<double>)) {
  TORCH_CUDASPARSE_CHECK(hipsparseZbsrsv2_analysis(
      handle,
      dirA,
      transA,
      mb,
      nnzb,
      descrA,
      reinterpret_cast<const hipDoubleComplex*>(bsrValA),
      bsrRowPtrA,
      bsrColIndA,
      blockDim,
      info,
      policy,
      pBuffer));
}

template <>
void bsrsv2_solve<float>(CUSPARSE_BSRSV2_SOLVE_ARGTYPES(float)) {
  TORCH_CUDASPARSE_CHECK(hipsparseSbsrsv2_solve(
      handle,
      dirA,
      transA,
      mb,
      nnzb,
      alpha,
      descrA,
      bsrValA,
      bsrRowPtrA,
      bsrColIndA,
      blockDim,
      info,
      x,
      y,
      policy,
      pBuffer));
}

template <>
void bsrsv2_solve<double>(CUSPARSE_BSRSV2_SOLVE_ARGTYPES(double)) {
  TORCH_CUDASPARSE_CHECK(hipsparseDbsrsv2_solve(
      handle,
      dirA,
      transA,
      mb,
      nnzb,
      alpha,
      descrA,
      bsrValA,
      bsrRowPtrA,
      bsrColIndA,
      blockDim,
      info,
      x,
      y,
      policy,
      pBuffer));
}

template <>
void bsrsv2_solve<c10::complex<float>>(
    CUSPARSE_BSRSV2_SOLVE_ARGTYPES(c10::complex<float>)) {
  TORCH_CUDASPARSE_CHECK(hipsparseCbsrsv2_solve(
      handle,
      dirA,
      transA,
      mb,
      nnzb,
      reinterpret_cast<const hipComplex*>(alpha),
      descrA,
      reinterpret_cast<const hipComplex*>(bsrValA),
      bsrRowPtrA,
      bsrColIndA,
      blockDim,
      info,
      reinterpret_cast<const hipComplex*>(x),
      reinterpret_cast<hipComplex*>(y),
      policy,
      pBuffer));
}

template <>
void bsrsv2_solve<c10::complex<double>>(
    CUSPARSE_BSRSV2_SOLVE_ARGTYPES(c10::complex<double>)) {
  TORCH_CUDASPARSE_CHECK(hipsparseZbsrsv2_solve(
      handle,
      dirA,
      transA,
      mb,
      nnzb,
      reinterpret_cast<const hipDoubleComplex*>(alpha),
      descrA,
      reinterpret_cast<const hipDoubleComplex*>(bsrValA),
      bsrRowPtrA,
      bsrColIndA,
      blockDim,
      info,
      reinterpret_cast<const hipDoubleComplex*>(x),
      reinterpret_cast<hipDoubleComplex*>(y),
      policy,
      pBuffer));
}

template <>
void bsrsm2_bufferSize<float>(CUSPARSE_BSRSM2_BUFFER_ARGTYPES(float)) {
  TORCH_CUDASPARSE_CHECK(hipsparseSbsrsm2_bufferSize(
      handle,
      dirA,
      transA,
      transX,
      mb,
      n,
      nnzb,
      descrA,
      bsrValA,
      bsrRowPtrA,
      bsrColIndA,
      blockDim,
      info,
      pBufferSizeInBytes));
}

template <>
void bsrsm2_bufferSize<double>(CUSPARSE_BSRSM2_BUFFER_ARGTYPES(double)) {
  TORCH_CUDASPARSE_CHECK(hipsparseDbsrsm2_bufferSize(
      handle,
      dirA,
      transA,
      transX,
      mb,
      n,
      nnzb,
      descrA,
      bsrValA,
      bsrRowPtrA,
      bsrColIndA,
      blockDim,
      info,
      pBufferSizeInBytes));
}

template <>
void bsrsm2_bufferSize<c10::complex<float>>(
    CUSPARSE_BSRSM2_BUFFER_ARGTYPES(c10::complex<float>)) {
  TORCH_CUDASPARSE_CHECK(hipsparseCbsrsm2_bufferSize(
      handle,
      dirA,
      transA,
      transX,
      mb,
      n,
      nnzb,
      descrA,
      reinterpret_cast<hipComplex*>(bsrValA),
      bsrRowPtrA,
      bsrColIndA,
      blockDim,
      info,
      pBufferSizeInBytes));
}

template <>
void bsrsm2_bufferSize<c10::complex<double>>(
    CUSPARSE_BSRSM2_BUFFER_ARGTYPES(c10::complex<double>)) {
  TORCH_CUDASPARSE_CHECK(hipsparseZbsrsm2_bufferSize(
      handle,
      dirA,
      transA,
      transX,
      mb,
      n,
      nnzb,
      descrA,
      reinterpret_cast<hipDoubleComplex*>(bsrValA),
      bsrRowPtrA,
      bsrColIndA,
      blockDim,
      info,
      pBufferSizeInBytes));
}

template <>
void bsrsm2_analysis<float>(CUSPARSE_BSRSM2_ANALYSIS_ARGTYPES(float)) {
  TORCH_CUDASPARSE_CHECK(hipsparseSbsrsm2_analysis(
      handle,
      dirA,
      transA,
      transX,
      mb,
      n,
      nnzb,
      descrA,
      bsrValA,
      bsrRowPtrA,
      bsrColIndA,
      blockDim,
      info,
      policy,
      pBuffer));
}

template <>
void bsrsm2_analysis<double>(CUSPARSE_BSRSM2_ANALYSIS_ARGTYPES(double)) {
  TORCH_CUDASPARSE_CHECK(hipsparseDbsrsm2_analysis(
      handle,
      dirA,
      transA,
      transX,
      mb,
      n,
      nnzb,
      descrA,
      bsrValA,
      bsrRowPtrA,
      bsrColIndA,
      blockDim,
      info,
      policy,
      pBuffer));
}

template <>
void bsrsm2_analysis<c10::complex<float>>(
    CUSPARSE_BSRSM2_ANALYSIS_ARGTYPES(c10::complex<float>)) {
  TORCH_CUDASPARSE_CHECK(hipsparseCbsrsm2_analysis(
      handle,
      dirA,
      transA,
      transX,
      mb,
      n,
      nnzb,
      descrA,
      reinterpret_cast<const hipComplex*>(bsrValA),
      bsrRowPtrA,
      bsrColIndA,
      blockDim,
      info,
      policy,
      pBuffer));
}

template <>
void bsrsm2_analysis<c10::complex<double>>(
    CUSPARSE_BSRSM2_ANALYSIS_ARGTYPES(c10::complex<double>)) {
  TORCH_CUDASPARSE_CHECK(hipsparseZbsrsm2_analysis(
      handle,
      dirA,
      transA,
      transX,
      mb,
      n,
      nnzb,
      descrA,
      reinterpret_cast<const hipDoubleComplex*>(bsrValA),
      bsrRowPtrA,
      bsrColIndA,
      blockDim,
      info,
      policy,
      pBuffer));
}

template <>
void bsrsm2_solve<float>(CUSPARSE_BSRSM2_SOLVE_ARGTYPES(float)) {
  TORCH_CUDASPARSE_CHECK(hipsparseSbsrsm2_solve(
      handle,
      dirA,
      transA,
      transX,
      mb,
      n,
      nnzb,
      alpha,
      descrA,
      bsrValA,
      bsrRowPtrA,
      bsrColIndA,
      blockDim,
      info,
      B,
      ldb,
      X,
      ldx,
      policy,
      pBuffer));
}

template <>
void bsrsm2_solve<double>(CUSPARSE_BSRSM2_SOLVE_ARGTYPES(double)) {
  TORCH_CUDASPARSE_CHECK(hipsparseDbsrsm2_solve(
      handle,
      dirA,
      transA,
      transX,
      mb,
      n,
      nnzb,
      alpha,
      descrA,
      bsrValA,
      bsrRowPtrA,
      bsrColIndA,
      blockDim,
      info,
      B,
      ldb,
      X,
      ldx,
      policy,
      pBuffer));
}

template <>
void bsrsm2_solve<c10::complex<float>>(
    CUSPARSE_BSRSM2_SOLVE_ARGTYPES(c10::complex<float>)) {
  TORCH_CUDASPARSE_CHECK(hipsparseCbsrsm2_solve(
      handle,
      dirA,
      transA,
      transX,
      mb,
      n,
      nnzb,
      reinterpret_cast<const hipComplex*>(alpha),
      descrA,
      reinterpret_cast<const hipComplex*>(bsrValA),
      bsrRowPtrA,
      bsrColIndA,
      blockDim,
      info,
      reinterpret_cast<const hipComplex*>(B),
      ldb,
      reinterpret_cast<hipComplex*>(X),
      ldx,
      policy,
      pBuffer));
}

template <>
void bsrsm2_solve<c10::complex<double>>(
    CUSPARSE_BSRSM2_SOLVE_ARGTYPES(c10::complex<double>)) {
  TORCH_CUDASPARSE_CHECK(hipsparseZbsrsm2_solve(
      handle,
      dirA,
      transA,
      transX,
      mb,
      n,
      nnzb,
      reinterpret_cast<const hipDoubleComplex*>(alpha),
      descrA,
      reinterpret_cast<const hipDoubleComplex*>(bsrValA),
      bsrRowPtrA,
      bsrColIndA,
      blockDim,
      info,
      reinterpret_cast<const hipDoubleComplex*>(B),
      ldb,
      reinterpret_cast<hipDoubleComplex*>(X),
      ldx,
      policy,
      pBuffer));
}

#endif // AT_USE_HIPSPARSE_TRIANGULAR_SOLVE

} // namespace at::cuda::sparse
