// !!! This is a file automatically generated by hipify!!!
// Original TunableOp is from onnxruntime.
// https://github.com/microsoft/onnxruntime/blob/main/onnxruntime/core/framework/tunable.h
// https://github.com/microsoft/onnxruntime/tree/main/onnxruntime/core/providers/rocm/tunable
// Copyright (c) Microsoft Corporation.
// Licensed under the MIT license.
//
// Adapting TunableOp into PyTorch
// Copyright (c) Advanced Micro Devices, Inc.
//
#include <hip/hip_runtime.h>

#include <ATen/hip/impl/HIPStreamMasqueradingAsCUDA.h>
#include <ATen/hip/Exceptions.h>
#include <ATen/hip/tunable/StreamTimer.h>

namespace at::cuda::tunable {

StreamTimer::StreamTimer() {
  AT_CUDA_CHECK(hipEventCreate(&start_));
  AT_CUDA_CHECK(hipEventCreate(&end_));
}

StreamTimer::~StreamTimer() {
}

void StreamTimer::Start() {
  AT_CUDA_CHECK(hipDeviceSynchronize());
  AT_CUDA_CHECK(hipEventRecord(start_, at::hip::getCurrentHIPStreamMasqueradingAsCUDA()));
}

void StreamTimer::End() {
  AT_CUDA_CHECK(hipEventRecord(end_, at::hip::getCurrentHIPStreamMasqueradingAsCUDA()));
  AT_CUDA_CHECK(hipEventSynchronize(end_));
}

float StreamTimer::Duration() {
  float time;
  // time is in ms with a resolution of 1 us
  AT_CUDA_CHECK(hipEventElapsedTime(&time, start_, end_));
  return time;
}

} // namespace at::cuda::tunable
